"use strict";
function sleep(ms) {
    return new Promise((resolve) => setTimeout(resolve, ms));
}
class Gamble extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1) {
        super(parent, __localStorage, elmtId);
        this.__theResult = new ObservedPropertySimplePU("快来玩，小赢家！", this, "theResult");
        this.__tipMessage = new ObservedPropertySimplePU("快来出拳吧！", this, "tipMessage");
        this.__setNum = new ObservedPropertySimplePU(0, this, "setNum");
        this.__progressValue = new ObservedPropertySimplePU(0, this, "progressValue");
        this.__mySwitch = new ObservedPropertySimplePU(0, this, "mySwitch");
        this.__systemSwitch = new ObservedPropertySimplePU(0, this, "systemSwitch");
        this.__systemSwitchPicture = new ObservedPropertyObjectPU({ "id": 16777219, "type": 20000, params: [], "bundleName": "com.example.fingerguessinggame", "moduleName": "entry" }, this, "systemSwitchPicture");
        this.play = [{ "id": 16777219, "type": 20000, params: [], "bundleName": "com.example.fingerguessinggame", "moduleName": "entry" }, { "id": 16777218, "type": 20000, params: [], "bundleName": "com.example.fingerguessinggame", "moduleName": "entry" }, { "id": 16777224, "type": 20000, params: [], "bundleName": "com.example.fingerguessinggame", "moduleName": "entry" }];
        this.j = 0;
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params) {
        if (params.theResult !== undefined) {
            this.theResult = params.theResult;
        }
        if (params.tipMessage !== undefined) {
            this.tipMessage = params.tipMessage;
        }
        if (params.setNum !== undefined) {
            this.setNum = params.setNum;
        }
        if (params.progressValue !== undefined) {
            this.progressValue = params.progressValue;
        }
        if (params.mySwitch !== undefined) {
            this.mySwitch = params.mySwitch;
        }
        if (params.systemSwitch !== undefined) {
            this.systemSwitch = params.systemSwitch;
        }
        if (params.systemSwitchPicture !== undefined) {
            this.systemSwitchPicture = params.systemSwitchPicture;
        }
        if (params.play !== undefined) {
            this.play = params.play;
        }
        if (params.j !== undefined) {
            this.j = params.j;
        }
    }
    updateStateVars(params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__theResult.purgeDependencyOnElmtId(rmElmtId);
        this.__tipMessage.purgeDependencyOnElmtId(rmElmtId);
        this.__setNum.purgeDependencyOnElmtId(rmElmtId);
        this.__progressValue.purgeDependencyOnElmtId(rmElmtId);
        this.__mySwitch.purgeDependencyOnElmtId(rmElmtId);
        this.__systemSwitch.purgeDependencyOnElmtId(rmElmtId);
        this.__systemSwitchPicture.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__theResult.aboutToBeDeleted();
        this.__tipMessage.aboutToBeDeleted();
        this.__setNum.aboutToBeDeleted();
        this.__progressValue.aboutToBeDeleted();
        this.__mySwitch.aboutToBeDeleted();
        this.__systemSwitch.aboutToBeDeleted();
        this.__systemSwitchPicture.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    get theResult() {
        return this.__theResult.get();
    }
    set theResult(newValue) {
        this.__theResult.set(newValue);
    }
    get tipMessage() {
        return this.__tipMessage.get();
    }
    set tipMessage(newValue) {
        this.__tipMessage.set(newValue);
    }
    get setNum() {
        return this.__setNum.get();
    }
    set setNum(newValue) {
        this.__setNum.set(newValue);
    }
    get progressValue() {
        return this.__progressValue.get();
    }
    set progressValue(newValue) {
        this.__progressValue.set(newValue);
    }
    get mySwitch() {
        return this.__mySwitch.get();
    }
    set mySwitch(newValue) {
        this.__mySwitch.set(newValue);
    }
    get systemSwitch() {
        return this.__systemSwitch.get();
    }
    set systemSwitch(newValue) {
        this.__systemSwitch.set(newValue);
    }
    get systemSwitchPicture() {
        return this.__systemSwitchPicture.get();
    }
    set systemSwitchPicture(newValue) {
        this.__systemSwitchPicture.set(newValue);
    }
    async GetResult() {
        this.progressValue = 0;
        for (var i = 0; i <= 100; i++) {
            var temple = await sleep(10);
            this.progressValue = i;
            if (i % 10 === 0) {
                this.j = this.j + 1;
                if (this.j >= 3) {
                    this.j = 0;
                }
                this.systemSwitchPicture = this.play[this.j];
            }
        }
        //Math.floor()向下取整数计算,Math.random()：产生一个[0，1)之间的随机数。
        this.setNum = Math.floor(Math.random() * 100 + 1); //随机产生1~100的整数
        if (this.setNum <= 33) {
            this.systemSwitch = 0;
        }
        else if (this.setNum <= 66) {
            this.systemSwitch = 1;
        }
        else {
            this.systemSwitch = 2;
        }
        if (this.systemSwitch === 0) {
            this.systemSwitchPicture = { "id": 16777218, "type": 20000, params: [], "bundleName": "com.example.fingerguessinggame", "moduleName": "entry" };
            if (this.mySwitch === 0) {
                this.theResult = "平局，再来一次.";
            }
            else if (this.mySwitch === 1) {
                this.theResult = "你输了.";
            }
            else if (this.mySwitch === 2) {
                this.theResult = "你赢了.";
            }
        }
        else if (this.systemSwitch === 1) {
            this.systemSwitchPicture = { "id": 16777219, "type": 20000, params: [], "bundleName": "com.example.fingerguessinggame", "moduleName": "entry" };
            if (this.mySwitch === 0) {
                this.theResult = "你赢了.";
            }
            else if (this.mySwitch === 1) {
                this.theResult = "平局，再来一次.";
            }
            else if (this.mySwitch === 2) {
                this.theResult = "你输了.";
            }
        }
        else if (this.systemSwitch === 2) {
            this.systemSwitchPicture = { "id": 16777224, "type": 20000, params: [], "bundleName": "com.example.fingerguessinggame", "moduleName": "entry" };
            if (this.mySwitch === 0) {
                this.theResult = "你输了.";
            }
            else if (this.mySwitch === 1) {
                this.theResult = "你赢了.";
            }
            else if (this.mySwitch === 2) {
                this.theResult = "平局，再来一次.";
            }
        }
    }
    initialRender() {
        this.observeComponentCreation((elmtId, isInitialRender) => {
            ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
            Column.create();
            Column.debugLine("pages/Index.ets(74:5)");
            Column.size({ width: "100%", height: '100%' });
            Column.justifyContent(FlexAlign.Start);
            Column.alignItems(HorizontalAlign.Center);
            if (!isInitialRender) {
                Column.pop();
            }
            ViewStackProcessor.StopGetAccessRecording();
        });
        this.observeComponentCreation((elmtId, isInitialRender) => {
            ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
            Text.create("欢迎来猜拳!");
            Text.debugLine("pages/Index.ets(75:7)");
            Text.fontColor(Color.Blue);
            Text.fontSize(45);
            Text.margin({ top: 75 });
            Text.textAlign(TextAlign.Center);
            Text.width("90%");
            if (!isInitialRender) {
                Text.pop();
            }
            ViewStackProcessor.StopGetAccessRecording();
        });
        Text.pop();
        this.observeComponentCreation((elmtId, isInitialRender) => {
            ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
            Image.create({ "id": 16777223, "type": 20000, params: [], "bundleName": "com.example.fingerguessinggame", "moduleName": "entry" });
            Image.debugLine("pages/Index.ets(81:7)");
            Image.size({ width: "80%", height: "25%" });
            if (!isInitialRender) {
                Image.pop();
            }
            ViewStackProcessor.StopGetAccessRecording();
        });
        this.observeComponentCreation((elmtId, isInitialRender) => {
            ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
            //系统出拳
            Row.create();
            Row.debugLine("pages/Index.ets(85:7)");
            //系统出拳
            Row.width("100%");
            //系统出拳
            Row.height("12%");
            //系统出拳
            Row.justifyContent(FlexAlign.Center);
            //系统出拳
            Row.margin({ top: 10, bottom: 10 });
            if (!isInitialRender) {
                //系统出拳
                Row.pop();
            }
            ViewStackProcessor.StopGetAccessRecording();
        });
        this.observeComponentCreation((elmtId, isInitialRender) => {
            ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
            Image.create(this.systemSwitchPicture);
            Image.debugLine("pages/Index.ets(86:9)");
            Image.size({ width: "25%", height: "100%" });
            if (!isInitialRender) {
                Image.pop();
            }
            ViewStackProcessor.StopGetAccessRecording();
        });
        //系统出拳
        Row.pop();
        this.observeComponentCreation((elmtId, isInitialRender) => {
            ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
            //进度条
            Progress.create({ value: this.progressValue, total: 100, type: ProgressType.Linear });
            Progress.debugLine("pages/Index.ets(92:7)");
            //进度条
            Progress.margin({ top: 10, bottom: 10 });
            //进度条
            Progress.style({ strokeWidth: 10 });
            if (!isInitialRender) {
                //进度条
                Progress.pop();
            }
            ViewStackProcessor.StopGetAccessRecording();
        });
        this.observeComponentCreation((elmtId, isInitialRender) => {
            ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
            //我的出拳
            Text.create(this.tipMessage);
            Text.debugLine("pages/Index.ets(96:7)");
            //我的出拳
            Text.fontColor(Color.Blue);
            //我的出拳
            Text.fontSize(30);
            //我的出拳
            Text.margin({ top: 10 });
            //我的出拳
            Text.textAlign(TextAlign.Start);
            //我的出拳
            Text.width("90%");
            if (!isInitialRender) {
                //我的出拳
                Text.pop();
            }
            ViewStackProcessor.StopGetAccessRecording();
        });
        //我的出拳
        Text.pop();
        this.observeComponentCreation((elmtId, isInitialRender) => {
            ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
            Row.create();
            Row.debugLine("pages/Index.ets(102:7)");
            Row.width("100%");
            Row.height("12%");
            Row.justifyContent(FlexAlign.SpaceAround);
            Row.margin({ top: 10, bottom: 10 });
            if (!isInitialRender) {
                Row.pop();
            }
            ViewStackProcessor.StopGetAccessRecording();
        });
        this.observeComponentCreation((elmtId, isInitialRender) => {
            ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
            Image.create({ "id": 16777218, "type": 20000, params: [], "bundleName": "com.example.fingerguessinggame", "moduleName": "entry" });
            Image.debugLine("pages/Index.ets(103:9)");
            Image.size({ width: "25%", height: "100%" });
            Image.onClick(() => {
                this.mySwitch = 0;
                this.GetResult();
            });
            if (!isInitialRender) {
                Image.pop();
            }
            ViewStackProcessor.StopGetAccessRecording();
        });
        this.observeComponentCreation((elmtId, isInitialRender) => {
            ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
            Image.create({ "id": 16777219, "type": 20000, params: [], "bundleName": "com.example.fingerguessinggame", "moduleName": "entry" });
            Image.debugLine("pages/Index.ets(110:9)");
            Image.size({ width: "25%", height: "100%" });
            Image.onClick(() => {
                this.mySwitch = 1;
                this.GetResult();
            });
            if (!isInitialRender) {
                Image.pop();
            }
            ViewStackProcessor.StopGetAccessRecording();
        });
        this.observeComponentCreation((elmtId, isInitialRender) => {
            ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
            Image.create({ "id": 16777224, "type": 20000, params: [], "bundleName": "com.example.fingerguessinggame", "moduleName": "entry" });
            Image.debugLine("pages/Index.ets(117:9)");
            Image.size({ width: "25%", height: "100%" });
            Image.onClick(() => {
                this.mySwitch = 2;
                this.GetResult();
            });
            if (!isInitialRender) {
                Image.pop();
            }
            ViewStackProcessor.StopGetAccessRecording();
        });
        Row.pop();
        this.observeComponentCreation((elmtId, isInitialRender) => {
            ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
            Text.create(this.theResult);
            Text.debugLine("pages/Index.ets(128:7)");
            Text.fontColor(Color.Blue);
            Text.fontSize(35);
            Text.margin({ top: 25 });
            Text.textAlign(TextAlign.Center);
            Text.width("90%");
            if (!isInitialRender) {
                Text.pop();
            }
            ViewStackProcessor.StopGetAccessRecording();
        });
        Text.pop();
        Column.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
ViewStackProcessor.StartGetAccessRecordingFor(ViewStackProcessor.AllocateNewElmetIdForNextComponent());
loadDocument(new Gamble(undefined, {}));
ViewStackProcessor.StopGetAccessRecording();
//# sourceMappingURL=Index.js.map